//
// IFSC.aidl
//
// Copyright 2009 FeliCa Networks, Inc.
// All Rights Reserved.
// FeliCa Networks, Inc. Proprietary/Confidential.
//
package com.felicanetworks.mfc;

import com.felicanetworks.mfc.DeviceList;
import com.felicanetworks.mfc.IFSCEventListener;
import com.felicanetworks.mfc.IFelica;
import com.felicanetworks.mfc.FelicaResultInfo;

/**
 * FSC APIs邽߂AIDLC^[tF[XłB
 * <p>
 */
interface IFSC {

    /**
     * FeliCaT[oƂ̃ICJn܂B
     * <p>
     *
     * @param url FeliCaT[oURL
     * @param deviceList <code>DeviceList</code>
     * @param fscEventListener <code>FSC</code> CxgXi
     * @param felica IFelicauWFNg
     * @return OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_ILLEGAL_ARGUMENT} w肳ꂽURL <code>null</code> ̏ꍇ
     *             <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} FeliCaT[oƂ̃IC̊Jnsꍇiڍׂ͉\QƁj
     *             <p>
     *             <table style="vertical-align: middle;" border="1" cellpadding="2" * cellspacing="2">
     *             <tbody>
     *             <tr>
     *             <th style="text-align: center;"></th> <th
     *             style="text-align: center;">^Cv</th>
     *             </tr>
     *             <tr>
     *             <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     *             <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     *             </tr>
     *             <tr>
     *             <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     *             <td>{@link FelicaException#TYPE_FELICA_NOT_SET}</td>
     *             </tr>
     *             <tr>
     *             <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     *             <td>{@link FelicaException#TYPE_DEVICELIST_NOT_SET}</td>
     *             </tr>
     *             <tr>
     *             <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     *             <td>{@link FelicaException#TYPE_LISTENER_NOT_SET}</td>
     *             </tr>
     *             <tr>
     *             <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     *             <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     *             </tr>
     *             <tr>
     *             <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     *             <td>{@link FelicaException#TYPE_COMMUNICATION_START_FAILED}</td>
     *             </tr>
     *             </tbody>
     *             </table>
     */
    FelicaResultInfo start(String url, in DeviceList deviceList, IFSCEventListener fscEventListener, IFelica felica);

    /**
     * FeliCaT[oƂ̃IC𒆒f܂B
     * <p>
     * <code>FSC</code> ICł͂ȂꍇAs܂B
     * <p>
     */
    void stop();

    /**
     * foCXv̌ʂIꍇɒʒm܂B
     * <p>
     * @param result 쏈
     */
    void notifyResult(in byte[] result);

    /**
     * foCXvExceptionꍇɒʒm܂B
     * <p>
     * @param msg G[bZ[W
     */
    void notifyError(in String msg );

}
